/*
* Author:          Patrick-Christopher Mattulat
* Company:         Lynar Studios
* E-Mail:          webmaster@lynarstudios.com
* Created:         2023-04-08
* Changed:         2024-05-31
*
* */

#ifndef LS_STD_JNI_METHOD_HPP
#define LS_STD_JNI_METHOD_HPP

#include <jni.h>
#include <ls-std/core/definition.hpp>
#include <ls-std/os/dynamic-goal.hpp>
#include <string>
#include <string_view>

namespace ls::std::core::experimental
{
  ls_std_class JniMethod
  {
    public:

      explicit JniMethod(const ::std::string &_methodIdentifier, const ::std::string &_methodSignature);
      ~JniMethod();

      [[nodiscard]] jmethodID getMethodId();
      [[nodiscard]] ::std::string getMethodIdentifier() const;
      [[nodiscard]] ::std::string getMethodSignature() const;
      void setMethodId(jmethodID _methodId);
      void setMethodIdentifier(::std::string_view _methodIdentifier);
      void setMethodSignature(::std::string_view _methodSignature);

    private:

      jmethodID methodId{};
      ::std::string methodIdentifier{};
      ::std::string methodSignature{};
  };
}

#endif
